<template>
    <div v-if="editor" role="toolbar" aria-label="Editor Toolbar">
        <component v-for="component in components" :is="component.component" :key="component.key" :editor="editor"/>
    </div>
</template>

<script setup lang="ts">
    import {computed} from 'vue'
    import type {Component} from 'vue'
    import type { TheEditor } from '../TheEditor';
    const props = defineProps<{
        editor?: TheEditor,
    }>()



    const components = computed(()=>{
        if (!props.editor) return []
        // TODO Layout

        let layout = props.editor.bar_layout.split(' ')
        let comp: {key: string, component: Component}[] = []
        layout.forEach((name, i) => {
            let c = props.editor!.bar_controls[name]
            // Don't add spacer components if this is
            // the first component, the last component,
            // or if the previous component is a spacer
            if (c) comp.push({key: `${name}-${i}`, component: c})
        })

        // Remove any double spacers or spacers at the end or start
        comp = comp.filter((c, i) => {
            if (c.key[0]=='|') {
                if (i == 0 || i == comp.length-1) return false
                if (comp[i-1].key[0]=='|') return false
            }
            return true
        })
    
        return comp
        // // Default to all components in default layout
        // return Object.entries(props.editor.bar_components).map(([name, component]) => {
        //     return {
        //         name: `the-edit-bar-${name}`,
        //         component
        //     }
        // })
    })



</script>